const C3 = self.C3;

const BEHAVIOR_INFO = {
    id: "skymen_follower",
    Acts: {
      "SetFollowMode": {
            "forward": (inst) => inst._SetFollowMode,
            
            "autoScriptInterface": false,
            },
"SetFollowSpeed": {
            "forward": (inst) => inst._SetFollowSpeed,
            
            "autoScriptInterface": true,
            },
"SetFollowDistance": {
            "forward": (inst) => inst._SetFollowDistance,
            
            "autoScriptInterface": true,
            },
"Follow": {
            "forward": (inst) => inst._Follow,
            
            "autoScriptInterface": false,
            },
"Unfollow": {
            "forward": (inst) => inst._Unfollow,
            
            "autoScriptInterface": true,
            },
"_SetAngleToAngleOfMotion": {
            "forward": (inst) => inst._SetAngleToAngleOfMotion,
            
            "autoScriptInterface": true,
            },
"_SetAxes": {
            "forward": (inst) => inst._SetAxes,
            
            "autoScriptInterface": true,
            },
"AddWaypoint": {
            "forward": (inst) => inst._AddWaypoint,
            
            "autoScriptInterface": true,
            },
"SetWaypoint": {
            "forward": (inst) => inst._SetWaypoint,
            
            "autoScriptInterface": true,
            },
"RemoveWaypoint": {
            "forward": (inst) => inst._RemoveWaypoint,
            
            "autoScriptInterface": true,
            },
"ClearWaypoints": {
            "forward": (inst) => inst._ClearWaypoints,
            
            "autoScriptInterface": true,
            }
    },
    Cnds: {
      "IsFollowing": {
            "forward": (inst) => inst._IsFollowing,
            
            "autoScriptInterface": true,
          },
"IsAngleSetToAngleOfMotion": {
            "forward": (inst) => inst._IsAngleSetToAngleOfMotion,
            
            "autoScriptInterface": true,
          }
    },
    Exps: {
      "FollowDistance": {
            "forward": (inst) => inst._FollowDistance,
            
            "autoScriptInterface": true,
          },
"FollowTargetUID": {
            "forward": (inst) => inst._FollowTargetUID,
            
            "autoScriptInterface": true,
          },
"Speed": {
            "forward": (inst) => inst._Speed,
            
            "autoScriptInterface": true,
          },
"AngleOfMotion": {
            "forward": (inst) => inst._AngleOfMotion,
            
            "autoScriptInterface": true,
          },
"WayPointX": {
            "forward": (inst) => inst._WayPointX,
            
            "autoScriptInterface": false,
          },
"WayPointY": {
            "forward": (inst) => inst._WayPointY,
            
            "autoScriptInterface": false,
          },
"WayPointZ": {
            "forward": (inst) => inst._WayPointZ,
            
            "autoScriptInterface": false,
          },
"WayPointAngle": {
            "forward": (inst) => inst._WayPointAngle,
            
            "autoScriptInterface": false,
          },
"WayPointCount": {
            "forward": (inst) => inst._WayPointCount,
            
            "autoScriptInterface": false,
          }
    },
  };

const camelCasedMap = new Map();

function camelCasify(str) {
  // If the string is already camelCased, return it
  if (camelCasedMap.has(str)) {
    return camelCasedMap.get(str);
  }
  // Replace any non-valid JavaScript identifier characters with spaces
  let cleanedStr = str.replace(/[^a-zA-Z0-9$_]/g, " ");

  // Split the string on spaces
  let words = cleanedStr.split(" ").filter(Boolean);

  // Capitalize the first letter of each word except for the first one
  for (let i = 1; i < words.length; i++) {
    words[i] = words[i].charAt(0).toUpperCase() + words[i].substring(1);
  }

  // Join the words back together
  let result = words.join("");

  // If the first character is a number, prepend an underscore
  if (!isNaN(parseInt(result.charAt(0)))) {
    result = "_" + result;
  }

  camelCasedMap.set(str, result);

  return result;
}

C3.Behaviors[BEHAVIOR_INFO.id] = class extends C3.SDKBehaviorBase {
  constructor(opts) {
    super(opts);
  }

  Release() {
    super.Release();
  }
};
const B_C = C3.Behaviors[BEHAVIOR_INFO.id];
B_C.Type = class extends C3.SDKBehaviorTypeBase {
  constructor(objectClass) {
    super(objectClass);
  }

  Release() {
    super.Release();
  }

  OnCreate() {}
};

//====== SCRIPT INTERFACE ======
const map = new WeakMap();

function getScriptInterface(parentClass, map) {
  return class extends parentClass {
    constructor() {
      super();
      map.set(this, parentClass._GetInitInst().GetSdkInstance());

      this.FOLLOW_MODES = {
        DIRECT: 0,
        WAYPOINT: 1,
        LERP: 2,
      };
    }

    SetFollowMode(mode) {
      map.get(this).SetFollowMode(mode);
    }

    Follow(object) {
      const inst = map.get(this);
      if (object.getFirstInstance) {
        object = object.getFirstInstance();
      }
      inst.target = inst._runtime.GetInstanceByUID(object.uid);
      this._StartTicking();
    }

    get wayPoints() {
      return map.get(this).wayPoints;
    }

    get instance() {
      return map.get(this);
    }
  };
}


const scriptInterface = getScriptInterface(self.IBehaviorInstance, map);

// extend script interface with plugin actions
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    B_C.Acts[camelCasify(key)].call(sdkInst, ...args);
  };
});

const addonTriggers = [];

// extend script interface with plugin conditions
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  if (!ace.autoScriptInterface || ace.isStatic || ace.isLooping) return;
  if (ace.isTrigger) {
    scriptInterface.prototype[camelCasify(key)] = function (callback, ...args) {
      const callbackWrapper = () => {
        const sdkInst = map.get(this);
        if (B_C.Cnds[camelCasify(key)].call(sdkInst, ...args)) {
          callback();
        }
      };
      this.addEventListener(key, callbackWrapper, false);
      return () => this.removeEventListener(key, callbackWrapper, false);
    };
  } else {
    scriptInterface.prototype[camelCasify(key)] = function (...args) {
      const sdkInst = map.get(this);
      return B_C.Cnds[camelCasify(key)].call(sdkInst, ...args);
    };
  }
});

// extend script interface with plugin expressions
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    return B_C.Exps[camelCasify(key)].call(sdkInst, ...args);
  };
});
//====== SCRIPT INTERFACE ======

//============ ACES ============
B_C.Acts = {};
B_C.Cnds = {};
B_C.Exps = {};
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  B_C.Acts[camelCasify(key)] = function (...args) {
    if (ace.forward) ace.forward(this).call(this, ...args);
    else if (ace.handler) ace.handler.call(this, ...args);
  };
});
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  B_C.Cnds[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
  if (ace.isTrigger && ace.autoScriptInterface) {
    addonTriggers.push({
      method: B_C.Cnds[camelCasify(key)],
      id: key,
    });
  }
});
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  B_C.Exps[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
});
//============ ACES ============

function getInstanceJs(parentClass, scriptInterface, addonTriggers, C3) {
  return class extends parentClass {
    constructor(inst, properties) {
      super(inst);

      this.followMode = 0;
      this.followSpeed = 0;
      this.followDistance = 0;
      this.setAngle = false;
      this.axes = {
        x: true,
        y: true,
        z: false,
        a: false,
      };
      this.target = null;
      this.autoTargetParent = false;

      if (properties) {
        this.followMode = properties[0];
        this.followSpeed = properties[1];
        this.followDistance = properties[2];
        this.setAngle = properties[3];
        this.axes = {
          x: properties[4],
          y: properties[5],
          z: properties[6],
          a: properties[7],
        };
        this.autoTargetParent = properties[8];
      }
      this.angleOfMotion = 0;
      this.wayPoints = [];

      if (this.autoTargetParent) {
        this._StartTicking();
      }
    }

    Release() {
      super.Release();
    }

    SaveToJson() {
      return {
        // save state for savegames
        followMode: this.followMode,
        followSpeed: this.followSpeed,
        followDistance: this.followDistance,
        setAngle: this.setAngle,
        targetUid: this.target ? this.target.GetUID() : -1,
        axes: this.axes,
        wayPoints: this.wayPoints,
      };
    }

    LoadFromJson(o) {
      // load state for savegames
      this.followMode = o.followMode;
      this.followSpeed = o.followSpeed;
      this.followDistance = o.followDistance;
      this.setAngle = o.setAngle;
      if (o.targetUid !== -1)
        this.target = this._runtime.GetInstanceByUID(o.targetUid);
      else this.target = null;
      this.axes = o.axes;
      this.wayPoints = o.wayPoints;
    }

    PushWayPoint(x, y, z, a) {
      if (this.followMode === 1) {
        this.wayPoints.push({
          x,
          y,
          z,
          a,
        });
      } else {
        this.wayPoints = [
          {
            x,
            y,
            z,
            a,
          },
        ];
      }
    }

    UpdateTarget() {
      if (this.target === null) {
        return;
      }
      const wi = this.target.GetWorldInfo();
      const x = wi.GetX();
      const y = wi.GetY();
      const z = wi.GetZElevation();
      const a = wi.GetAngle();
      this.PushWayPoint(x, y, z, a);
    }

    Distance1D(start, end) {
      return Math.abs(end - start);
    }

    Distance2D(start, end) {
      const dx = end.x - start.x;
      const dy = end.y - start.y;
      return Math.sqrt(dx * dx + dy * dy);
    }

    Distance3D(start, end) {
      const dx = end.x - start.x;
      const dy = end.y - start.y;
      const dz = end.z - start.z;
      return Math.sqrt(dx * dx + dy * dy + dz * dz);
    }

    Distance(start, end) {
      if (this.axes.x && this.axes.y && this.axes.z) {
        return this.Distance3D(start, end);
      } else if (this.axes.x && this.axes.y) {
        return this.Distance2D(start, end);
      } else if (this.axes.x && this.axes.z) {
        return this.Distance2D(
          {
            x: start.x,
            y: start.z,
          },
          {
            x: end.x,
            y: end.z,
          }
        );
      } else if (this.axes.y && this.axes.z) {
        return this.Distance2D(
          {
            x: start.y,
            y: start.z,
          },
          {
            x: end.y,
            y: end.z,
          }
        );
      } else if (this.axes.x) {
        return this.Distance1D(start.x, end.x);
      } else if (this.axes.y) {
        return this.Distance1D(start.y, end.y);
      } else if (this.axes.z) {
        return this.Distance1D(start.z, end.z);
      } else {
        return 0;
      }
    }

    RemainingDistance() {
      const wi = this._inst.GetWorldInfo();
      const curPos = {
        x: wi.GetX(),
        y: wi.GetY(),
        z: wi.GetZElevation(),
      };

      let distance = this.Distance(curPos, this.wayPoints[0]);
      for (let i = 0; i < this.wayPoints.length - 1; i++) {
        distance += this.Distance(this.wayPoints[i], this.wayPoints[i + 1]);
      }
      return distance;
    }

    Tick() {
      const wi = this._inst.GetWorldInfo();
      if (this.target === null && this.autoTargetParent && wi.HasParent()) {
        const parWi = wi.GetParent();
        this.target = parWi._inst;
        parWi.RemoveChild(wi);
        this.autoTargetParent = false;
      }

      if (this.target === null && this.wayPoints.length === 0) {
        this._StopTicking();
        return;
      }
      if (this.target !== null) this.UpdateTarget();
      const curPos = {
        x: wi.GetX(),
        y: wi.GetY(),
        z: wi.GetZElevation(),
      };

      let speed = this.followSpeed;

      let endPos = {
        x: curPos.x,
        y: curPos.y,
        z: curPos.z,
      };

      const remainingDistance = this.RemainingDistance();

      let lastAngle = null;
      if (this.followMode === 1 && speed < 0) {
        if (remainingDistance > this.followDistance) {
          while (this.wayPoints.length > Math.abs(speed)) {
            let nextWp = this.wayPoints.shift();
            if (nextWp) {
              endPos = {
                x: nextWp.x,
                y: nextWp.y,
                z: nextWp.z,
              };
            }
          }
        }
      } else {
        const dt = this._runtime.GetDt(this._inst);
        if (this.followMode === 2) {
          speed =
            Math.max(0, remainingDistance - this.followDistance) *
            this.followSpeed;
        }

        let distance = 0;
        let maxDistance = Math.min(
          speed * dt,
          Math.max(0, remainingDistance - this.followDistance)
        );

        if (maxDistance <= 0) {
          return;
        }

        while (this.wayPoints.length > 0 && distance < maxDistance) {
          const wp = this.wayPoints[0];
          // the distance to calculate needs to take into account only the axes
          // that are enabled
          const dist = this.Distance(curPos, wp);
          if (dist <= maxDistance - distance) {
            this.wayPoints.shift();
            distance += dist;
            if (this.axes.a) {
              lastAngle = wp.a;
            }
            if (this.axes.x) {
              endPos.x = wp.x;
            }
            if (this.axes.y) {
              endPos.y = wp.y;
            }
            if (this.axes.z) {
              endPos.z = wp.z;
            }
          } else {
            const moveFraction = (maxDistance - distance) / dist;
            if (this.axes.x) {
              endPos.x = endPos.x + (wp.x - endPos.x) * moveFraction;
            }
            if (this.axes.y) {
              endPos.y = endPos.y + (wp.y - endPos.y) * moveFraction;
            }
            if (this.axes.z) {
              endPos.z = endPos.z + (wp.z - endPos.z) * moveFraction;
            }
            if (this.axes.a) {
              if (lastAngle !== null)
                lastAngle = C3.angleLerp(lastAngle, wp.a, moveFraction);
              else lastAngle = wp.a;
            }
            distance = maxDistance;
          }
        }
      }

      if (
        Object.keys(endPos).every((k) => {
          if (this.axes[k]) {
            return endPos[k] === curPos[k];
          } else {
            return true;
          }
        })
      ) {
        return;
      }

      if (this.axes.x && this.axes.y)
        this.angleOfMotion = C3.angleTo(curPos.x, curPos.y, endPos.x, endPos.y);
      if (this.setAngle && this.axes.a && lastAngle !== null) {
        wi.SetAngle(lastAngle);
      } else if (this.setAngle && this.axes.x && this.axes.y) {
        wi.SetAngle(this.angleOfMotion);
      }

      if (this.axes.x) {
        wi.SetX(endPos.x);
      }
      if (this.axes.y) {
        wi.SetY(endPos.y);
      }
      if (this.axes.z) {
        wi.SetZElevation(endPos.z);
      }
      wi.SetBboxChanged();
    }

    Trigger(method) {
      super.Trigger(method);
      const addonTrigger = addonTriggers.find((x) => x.method === method);
      if (addonTrigger) {
        this.GetScriptInterface().dispatchEvent(new C3.Event(addonTrigger.id));
      }
    }

    GetScriptInterfaceClass() {
      return scriptInterface;
    }

    // ==== ACTIONS ====
    _SetFollowMode(mode) {
      this.followMode = mode;
    }
    _SetFollowSpeed(speed) {
      this.followSpeed = speed;
    }
    _SetFollowDistance(distance) {
      this.followDistance = distance;
    }
    _Follow(object) {
      this.target = object.GetFirstPicked();
      this.wayPoints = [];
      this._StartTicking();
    }
    _Unfollow() {
      this.target = null;
      this.wayPoints = [];
      this._StopTicking();
    }
    _SetAngleToAngleOfMotion(angle) {
      this.setAngle = angle;
    }
    _SetAxes(x, y, z) {
      this.axes = {
        x,
        y,
        z,
      };
    }
    _AddWaypoint(x, y, z, a) {
      this.PushWayPoint(x, y, z, a);
    }
    _ClearWaypoints() {
      this.wayPoints = [];
    }
    _SetWaypoint(index, x, y, z, a) {
      if (index >= this.wayPoints.length || index < 0) {
        return;
      }
      this.wayPoints[index] = {
        x,
        y,
        z,
        a,
      };
    }
    _RemoveWaypoint(index) {
      if (index >= this.wayPoints.length || index < 0) {
        return;
      }
      this.wayPoints.splice(index, 1);
    }
    // ==== CONDITIONS ====
    _IsFollowing() {
      return this.wayPoints.length > 0 || this.target !== null;
    }
    _IsAngleSetToAngleOfMotion() {
      return this.setAngle;
    }
    // ==== EXPRESSIONS ====
    _FollowDistance() {
      return this.followDistance;
    }
    _FollowTargetUID() {
      return this.target ? this.target.GetUID() : -1;
    }
    _Speed() {
      return this.followSpeed;
    }
    _AngleOfMotion() {
      return this.angleOfMotion;
    }
    _WayPointX(index) {
      if (index >= this.wayPoints.length || index < 0) {
        return;
      }
      return this.wayPoints[index].x;
    }
    _WayPointY(index) {
      if (index >= this.wayPoints.length || index < 0) {
        return;
      }
      return this.wayPoints[index].y;
    }
    _WayPointZ(index) {
      if (index >= this.wayPoints.length || index < 0) {
        return;
      }
      return this.wayPoints[index].z;
    }
    _WayPointAngle(index) {
      if (index >= this.wayPoints.length || index < 0) {
        return;
      }
      return this.wayPoints[index].a;
    }
    _WayPointCount(index) {
      this.wayPoints.length;
    }
  };
}


B_C.Instance = getInstanceJs(
  C3.SDKBehaviorInstanceBase,
  scriptInterface,
  addonTriggers,
  C3
);
